com.io7m.jstructural.annotated

## Class SASection

- java.lang.Object
- - com.io7m.jstructural.annotated.SASection

- All Implemented Interfaces:
    SAIDTargetContent
  Direct Known Subclasses:
    SASectionWithParagraphs, SASectionWithSubsections

      @Immutable
      public abstract class SASection
      extends Object
      implements SAIDTargetContent

  An abstract section.

- - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `SASection(SASectionNumber in_number, com.io7m.jaux.functional.Option<String> in_type, com.io7m.jaux.functional.Option<SAID> in_id, SASectionTitle in_title, com.io7m.jaux.functional.Option<SSectionContents> in_contents, List<SAFootnote> in_footnotes)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `equals(Object obj)`
    `com.io7m.jaux.functional.Option<SSectionContents>` | `getContents()`
    `List<SAFootnote>` | `getFootnotes()`
    `com.io7m.jaux.functional.Option<SAID>` | `getID()`
    `SASectionNumber` | `getNumber()`
    `SASectionTitle` | `getTitle()`
    `com.io7m.jaux.functional.Option<String>` | `getType()`
    `int` | `hashCode()`
    `abstract <A> A` | `sectionAccept(SASectionVisitor<A> v)` Accept a section visitor.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.io7m.jstructural.annotated.SAIDTargetContent

      `targetContentAccept`

- - ### Constructor Detail

    - #### SASection

          protected SASection(@Nonnull
                   SASectionNumber in_number,
                   @Nonnull
                   com.io7m.jaux.functional.Option<String> in_type,
                   @Nonnull
                   com.io7m.jaux.functional.Option<SAID> in_id,
                   @Nonnull
                   SASectionTitle in_title,
                   @Nonnull
                   com.io7m.jaux.functional.Option<SSectionContents> in_contents,
                   @Nonnull
                   List<SAFootnote> in_footnotes)
                       throws com.io7m.jaux.Constraints.ConstraintError

      Throws:
        `com.io7m.jaux.Constraints.ConstraintError`

  - ### Method Detail

    - #### equals

          public boolean equals(Object obj)

      Overrides:
        `equals` in class `Object`

    - #### getContents

          @Nonnull
          public final com.io7m.jaux.functional.Option<SSectionContents> getContents()

      Returns:
        The section contents

    - #### getFootnotes

          public final List<SAFootnote> getFootnotes()

      Returns:
        The list of footnotes for this section

    - #### getID

          @Nonnull
          public final com.io7m.jaux.functional.Option<SAID> getID()

      Returns:
        The section ID

    - #### getNumber

          @Nonnull
          public final SASectionNumber getNumber()

      Returns:
        The section number

    - #### getTitle

          @Nonnull
          public final SASectionTitle getTitle()

      Returns:
        The section title

    - #### getType

          @Nonnull
          public final com.io7m.jaux.functional.Option<String> getType()

      Returns:
        The section type attribute

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### sectionAccept

          public abstract <A> A sectionAccept(@Nonnull
                            SASectionVisitor<A> v)
                                   throws com.io7m.jaux.Constraints.ConstraintError,
                                          Exception

      Accept a section visitor.
      Type Parameters:
        `A` - The type of values returned by the visitor
      Parameters:
        `v` - The visitor
      Returns:
        The value returned by the visitor
      Throws:
        `com.io7m.jaux.Constraints.ConstraintError` - If the visitor raises `Constraints.ConstraintError`
        `Exception` - If the visitor raises an `Exception`

Copyright © 2014. All rights reserved.